﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Net.Security;
using HeuristicLab.Services.Optimization.ControllerService.Model;

namespace HeuristicLab.Services.Optimization.ControllerService {
  [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
  public interface IControllerService {
    [OperationContract]
    IEnumerable<OptimizationScenario> GetOptimizationScenarios();

    [OperationContract]
    IEnumerable<string> GetOptimizationScenarioNames();

    [OperationContract]
    OptimizationScenario GetOptimizationScenarioByName(string name);

    [OperationContract]
    bool ScheduleOptimizationScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);

    [OperationContract]
    bool ScheduleExperiment(User user, string experiment, JobExecutionDetails details);

    [OperationContract]
    IEnumerable<Job> GetJobs(User user);

    [OperationContract]
    Job GetJob(User user, string id);

    [OperationContract]
    bool DeleteJob(User user, string id);

    [OperationContract]
    IList<Model.Run> GetJobResults(User user, string id);

    [OperationContract]
    bool AddHiveScenario(User user, string scenarioXml, string scenarioMapper);

    [OperationContract]
    bool DeleteHiveScenario(User user, string scenarioName);

    [OperationContract]
    string SaveExperiment(User user, Experiment experiment);

    [OperationContract]
    IEnumerable<string> GetExperimentNames(User user);

    [OperationContract]
    IEnumerable<Experiment> GetExperiments(User user, bool namesOnly = false);

    [OperationContract]
    bool DeleteExperiment(User user, string experiment);

    [OperationContract]
    Job GetTasks(User u, string jobId);

    [OperationContract]
    Task GetTaskData(User u, string jobId, string taskId);

    [OperationContract]
    Experiment GetExperimentByName(User user, string scenario);

    [OperationContract]
    Experiment GetExperimentById(User u, string nodeId);
  }
}
